package flowsim.cbdv;

import flowsim.core.*;
import flowsim.dv.*;

public class CBDVRouter0 extends CBDVRouter {
	static final double DELAY_FACTOR = 0; // cost of LINK_DELAY_NORM
	static final double HOPCOUNT_FACTOR = 1;
	static final double INVBW_FACTOR = 0; // maximal cost for invbw

	public static ServiceFactory cbdv0_factory(final Simulator s) {
		return new ServiceFactory() {
			public Service create(Node node, int route) {
				return new CBDVRouter0(s,node,route);
			}
		};
	}

	public double get_delay_factor() {
		return DELAY_FACTOR;
	}

	public double get_hopcount_factor() {
		return HOPCOUNT_FACTOR;
	}

	public double get_invbw_factor() {
		return INVBW_FACTOR;
	}

	public CBDVRouter0(Simulator s, Node n, int r) {
		super(s, n, r);
	}
}

