package flowsim.cbdv;

import flowsim.core.*;
import flowsim.dv.*;

public final class CBDVRouter1 extends CBDVRouter {
	static final double DELAY_FACTOR = 0; // cost of LINK_DELAY_NORM
	static final double HOPCOUNT_FACTOR = 0;
	static final double INVBW_FACTOR = 50; // maximal cost for invbw
	static final int    COST_THRESHOLD = 5;

	public static ServiceFactory cbdv1_factory(final Simulator s) {
		return new ServiceFactory() {
			public Service create(Node node, int route) {
				return new CBDVRouter1(s,node,route);
			}
		};
	}

	protected final int cost_threshold() {
		return COST_THRESHOLD;
	}

	public double get_delay_factor() {
		return DELAY_FACTOR;
	}

	public double get_hopcount_factor() {
		return HOPCOUNT_FACTOR;
	}

	public double get_invbw_factor() {
		return INVBW_FACTOR;
	}

	public CBDVRouter1(Simulator s, Node n, int r) {
		super(s, n, r);
	}
}
