package flowsim.cbdv;

import flowsim.core.*;

public class CBDVUnicastFlow extends QoSUnicastFlowImpl
{
	static final int DS_SERVICE0  = 2; // traditional
	static final int DS_SERVICE1  = 3; // bw constrained
	static final int DS_SERVICE2  = 4;
	static final int DS_SERVICE3  = 5; // delay constrained
	static final int BW_THRESHOLD = 16000; // 16 kbit/s
	static final int DL_THRESHOLD = 60000; // 60 ms

	                                // 0  1  2  3  4  5
	static final int[] DS_PORT_MAP = { 0, 0, 0, 1, 2, 3 };

	int max_delay;
	int total_delay;
	boolean is_be; 
	
	void to_ds() {
		if(is_be) {
			set_ds(FlowImpl.DS_BEST_EFFORT);
		}
		else {
			if(get_bw()>BW_THRESHOLD) {
				if(max_delay < DL_THRESHOLD) set_ds(DS_SERVICE2);
				else set_ds(DS_SERVICE1);
			}
			else {
				if(max_delay < DL_THRESHOLD) set_ds(DS_SERVICE3);
				else set_ds(DS_SERVICE0);
			}
		}
	}


	public CBDVUnicastFlow(Simulator s, Node from, Node to, int bw,
			int flow, int max_delay, int min_bw, boolean is_be)
	{
		super(s, from, to, bw, flow, 0, 0, max_delay, min_bw, is_be);
		to_ds();
		set_router_port(DS_PORT_MAP[get_ds()]);
	}
}
