package flowsim.core;

import java.util.Random;

public class FixedDelayLink extends LinkImpl
{
	final int delay; // in microseconds

	public static LinkFactory factory(final Simulator s, final int bw, final int delay) {
		return new LinkFactory() {
			public Link create(Node from, Node to) {
				return new FixedDelayLink(s,from,to,bw,delay);
			}
		};
	}

	public static LinkFactory randomdelay_factory(final Simulator s,
		final int bw, final int min_delay, final int max_delay,
		final long seed)
	{
		final Random r = new Random(seed);
		return new LinkFactory() {
			public Link create(Node a, Node b) {
				int delay = (int)(min_delay+r.nextFloat()*(max_delay-min_delay));
				return new FixedDelayLink(s,a,b,bw,delay);
			}
		};
	}

	public int get_delay() {
		return delay;
	}

	public FixedDelayLink(Simulator s, Node from, Node to, int bw, int delay) {
		super(s,from,to,bw);
		this.delay = delay;
	}
}
