package flowsim.core;

import flowsim.util.StringFormatter;
import java.io.PrintStream;

public class Logger {
	Simulator s;
	PrintStream err;
	PrintStream dbg;

	public void error(Object who, String str) {
		err.print("ERR ");
		print(who,str,err);
		err.flush();
	}

	public void debug(Object who, String str) {
		dbg.print("    ");
		print(who,str,dbg);
	}

	void print(Object who, String str, PrintStream ps) {
		print_time(ps);
		ps.print("  ");
		ps.print(StringFormatter.left_justified(who.toString(),20,true));
		ps.print(" ");
		ps.println(str);
	}

	void print_time(PrintStream ps) {
		String timestr = ""+s.now();
		ps.print(StringFormatter.right_justified(timestr,10,true));
	}

	public Logger(Simulator s, PrintStream err, PrintStream dbg) {
		this.s  = s;
		this.err = err;
		this.dbg = dbg;
	}
}
