package flowsim.core;

/**
 * UnicastFlow special case which is not routed and which goes only from a
 * source to one of it's neighbours. It doesn't have 'childs'.
 */
final public class NextHopFlow extends FlowImpl implements UnicastFlow
{
	final LinkManager iface;

	public void next_node(Node child_node) {}

	public Node get_to() {
		return iface.get_peer();
	}

	public UnicastFlow get_parent() {
		return null;
	}

	public UnicastFlow get_child() {
		return null;
	}

	public LinkManager get_iface() {
		return iface;
	}

	public UnicastFlow add_child_same_node() {
		return null;
	}

	public void set_parent_bw(int bw) {}

	public void start() {
		super.start();

		iface.add(this);

		//System.err.println("Started...");
	}

	public void stop() {
		super.stop();

		iface.remove(this);
		//System.err.println("Stopped...");
	}

	public void block() {
		super.block();

		//System.err.println("Blocked...");
	}

	public NextHopFlow(Node from, LinkManager iface,
		int desired_bw, int flow_id, int ds)
	{
		super(from,desired_bw,flow_id,ds);
		this.iface = iface;
	}
}
