package flowsim.core;

public class QoSUnicastFlowImpl extends UnicastFlowImpl implements QoSUnicastFlow
{
	int min_bw;
	int max_delay;
	int total_delay;
	boolean is_be; 

	public final int get_max_delay() {
		return max_delay;
	}
	
	public final int get_min_bw() {
		return min_bw;
	}
	
	public final boolean is_be() {
		return is_be;
	}

	protected UnicastFlow mkchild(Node child_node) {
		QoSUnicastFlowImpl f = new QoSUnicastFlowImpl(s,child_node,get_to(),
			get_bw(), get_flowid(), get_ds(), get_router_port(),
			max_delay, min_bw, is_be);
		f.set_parent(this);
		f.total_delay = total_delay;
		return f;
	}

	public void forward(LinkManager lm) {
		total_delay+=lm.get_link().get_delay();

		if(total_delay>max_delay) {
			block();
			return;
		}

		super.forward(lm);
	}

	public void set_bw(int abw, int bw) {
		super.set_bw(abw, bw);

		if(bw<min_bw) block();
	}

	public QoSUnicastFlowImpl(Simulator s, Node from, Node to, int bw,
			int flow, int ds, int rport, int max_delay, int min_bw,
			boolean is_be)
	{
		super(s, from, to, bw, flow, ds, rport);
		this.max_delay = max_delay;
		this.min_bw = min_bw;
		this.is_be = is_be;
	}
}
