package flowsim.core;

public abstract class RouterImpl implements Router, Service, NodeMonitor
{
	protected final Simulator s;
	protected final Node node;
	protected final int port;

	// route flow 'flow' by calling flow.forward with the approptiate
	// LinkManager (interface)
	public abstract void route(Flow flow);

	public final Node get_node() {
		return node;
	}

	public final int get_port() {
		return port;
	}

	public void iface_changed(Node n, int i) {}

	public RouterImpl(Simulator s, Node node, int port) {
		this.s    = s;
		this.node = node;
		this.port = port;
		node.set_service(this,port);
		node.attach_monitor((NodeMonitor) this);
	}
}
