package flowsim.core;

/**
 * Entity which receives messages on a specific port-number of a node.  The
 * Message object asks when it arrives on a Node the Service object at a port
 * number and then converts this object to what it thinks it should be and
 * calls the appropriate method.
 *
 * @see Message
 */
public interface Service
{
	/**
	 * Get node on which this service resides.
	 */
	Node get_node();

	/**
	 * Get port-number on which this service resides.
	 */
	int get_port();
}
