package flowsim.core;

import java.io.PrintWriter;
import java.io.FileOutputStream;

public class TotalBandwidthMonitor implements LinkMonitor
{
	Simulator s;
	long bw;
	long old_bw;
	long old_time;
	PrintWriter pw;
	boolean flushed = true;

	public void add_flow(int fbw) {
		//s.debug(this,"add_flow("+fbw+")");
		bw += fbw;
		log();
	}

	public void remove_flow(int fbw) {
		//s.debug(this,"remove_flow("+fbw+")");
		bw -= fbw;
		if(bw<0) bw=0;
		log();
	}

	void log() {
		flushed = false;
		if(pw != null) {
			if(old_time != s.now()) {
				pw.println(old_time+"\t"+old_bw);
				old_time = s.now();
			}
			old_bw  = bw;
		}
	}

	public void flush() {
		if(!flushed) {
			log();
			if(pw != null) pw.println(old_time+"\t"+old_bw);
			old_time = s.now();
			old_bw  = bw;
			flushed=true;
		}
	}

	TotalBandwidthMonitor(Simulator s, PrintWriter pw) {
		this.s = s;
		bw = 0;
		old_bw = 0;
		old_time = 0;
		this.pw = pw;
		log();
	}
}
