package flowsim.core;

public interface UnicastFlow extends Flow
{
	void next_node(Node child_node);
	Node get_to();
	UnicastFlow get_parent();
	UnicastFlow get_child();
	LinkManager get_iface();
	/**
	 * Set the child to a clone of this flow. This is used for for example
	 * in special cases of routing, where another object has a reference
	 * to the flow, but you want to modify it (for example the ds byte).
	 * This is very special and is normally not used. Note that you have
	 * to start() the flow after that.
	 * @return Child flow originating on the same node
	 */
	UnicastFlow add_child_same_node();
	void set_parent_bw(int bw);
}
