package flowsim.dv;

import flowsim.core.*;

import java.util.Enumeration;
import java.util.Hashtable;

public final class DVTableImpl implements DVTable
{
	Hashtable table;

	class TableEntry
	{
		int cost;
		TableEntry() { cost = DVRouterImpl.INFINITY; }
		TableEntry(int cost) { this.cost = cost; }
	}

	public void put(Node n, int cost) {
		TableEntry e;
		if(table.contains(n)==false) {
			e = new TableEntry(cost);
			table.put(n,e);
		}
		else {
			e = (TableEntry) table.get(n);
		}
		e.cost = cost;
	}

	public int get(Node n) {
		TableEntry e = (TableEntry) table.get(n);
		if(e==null) return DVRouterImpl.INFINITY;
		return e.cost;
	}

	public Enumeration nodes() {
		return table.keys();
	}

	public int size() {
		return table.size();
	}

	public Object clone() {
		try {
			return super.clone();
		}
		catch(CloneNotSupportedException e) {}
		return null;
	}
	
	DVTableImpl() { table = new Hashtable(); }
}
