package flowsim.dv;

import flowsim.core.*;

import java.util.Enumeration;

import com.sun.java.util.collections.Collections;
import com.sun.java.util.collections.Map;
import com.sun.java.util.collections.TreeMap;
import com.sun.java.util.collections.Comparator;

public final class DVTableSorted implements DVTable, Cloneable
{
	class NodeComparator implements Comparator
	{
		public final int compare(Object fst, Object snd) {
			Node a = (Node) fst;
			Node b = (Node) snd;
			return a.get_id()-b.get_id();
		}
	}

	class TableEntry
	{
		int cost;
		TableEntry() { cost = DVRouterImpl.INFINITY; }
		TableEntry(int cost) { this.cost = cost; }
	}

        Map table;

        public void put(Node n, int cost) {
                TableEntry e;
                if(table.containsKey(n)==false) {
                        e = new TableEntry(cost);
                        table.put(n,e);
                }
                else {
                        e = (TableEntry) table.get(n);
                }
                e.cost = cost;
        }

        public int get(Node n) {
                if(table.containsKey(n)==false) return DVRouterImpl.INFINITY;
                TableEntry e = (TableEntry) table.get(n);
                return e.cost;
        }

        public Enumeration nodes() {
                return Collections.enumeration(table.keySet());
        }

        public int size() {
                return table.size();
        }

        public Object clone() {
                try {
                        return super.clone();
                }
                catch(CloneNotSupportedException e) {}
                return null;
        }

        DVTableSorted() { table = new TreeMap(new NodeComparator()); }
}
