package flowsim.dv;

import flowsim.core.Message;
import flowsim.core.Node;

public final class DVUpdateMessage implements Message
{
	static final int PACKET_SIZE_0    = 10; // initial
	static final int PACKET_SIZE_NODE = 4;  // per node

	final Node from;
	final DVRouter router;
	final DVTable  table;
	final int count;

	public int size() {
		return PACKET_SIZE_0+count*PACKET_SIZE_NODE;
	}

	public void arrived(Node to) {
		router.receive_update(from,table);
	}

	public DVUpdateMessage(Node from, DVRouter router, DVTable table, int count) {
		this.from   = from;
		this.router = router;
		this.table  = table;
		this.count  = count;
	}
}
