package flowsim.slatr;

import flowsim.core.Node;

final class SLAId {
	int peer;
	int dest_id;
	int ds;
	String dest_name;

	public boolean equals(Object obj) {
		SLAId slaid = (SLAId) obj;
		// System.out.println("Testing equality.");
		if(peer!= slaid.peer) return false;
		if(dest_id != slaid.dest_id) return false;
		if(ds != slaid.ds) return false;
		return true;
	}

	public int hashCode() {
		return (peer<<8+dest_id<<4+ds);
	}

	public String toString() {
		return "["+peer+": "+dest_name+", "+ds+"]";
	}

	SLAId(int peer, Node dest, int ds) {
		this(peer, dest.get_id(), ds);
		dest_name=dest.toString();
	}

	SLAId(int peer, int dest_id, int ds) {
		this.peer = peer;
		this.dest_id=dest_id;
		this.ds=ds;
		this.dest_name="#"+dest_id;
	}

	SLAId(SLA sla) {
		this(sla.peer, sla.dest, sla.ds);
	}
}
