package flowsim.slatr;

import flowsim.core.*;

import java.util.Random;

public class SLATRouterGreedy extends SLATRouterImpl
{
	final static boolean DEBUG         = true;
	final static long    ACCEPT_MARGIN = 2*BASIS_CYCLE_TIME;

        protected void bid_received(SLA bid) {
                if(bid.expiration < s.now()+ACCEPT_MARGIN) return;
                if(bid.iface<0) return;
		if(bid.peer<0) return; // don't buy neighbour bids
                if(bid.cost>budget) return;

                if(has_link_space(bid)) {
                        accept_bid(bid);
                }
                else {
                        if(DEBUG) s.debug(this,"Can't accept bid: link_rbw too small");
                }
	}

	public String toString() {
		return "SLATRouterGreedy("+get_node()+")";
	}

	public SLATRouterGreedy(Simulator s, Node node, int port,
		int local_peers, long budget, long fixed_costs, Random random)
	{
		super(s,node,port,local_peers,budget,fixed_costs,random);
	}
}
