package flowsim.slatr;

import flowsim.core.Node;
import flowsim.core.Service;

interface User extends Service
{
	/**
	 * Get the current budget.
	 */
	long get_budget();

	/**
	 * returns by how much the budget is increased per second.
	 */
	long get_budget_incr();

	/**
	 * Increase the budget.
	 */
	void add_to_budget(long money);

	/**
	 * Decrease the budget.
	 */
	void remove_from_budget(long money);

	/**
	 * Print some statistics about this user.
	 */
	void print_stats();

	/**
	 * How much utility could have received this user if all went the best
	 * possible?
	 */
	float get_max_utility();

	/**
	 * What is the utility received so far?
	 */
	float get_utility();
}
