package flowsim.util;

import com.sun.java.util.collections.Iterator;

public final class CompositeIterator implements Iterator
{
	final Iterator it1;
	final Iterator it2;
	boolean is_first;
	boolean remove_first;

	public boolean hasNext() {
		if(!is_first || !it1.hasNext()) {
			return it2.hasNext();
		}
		return true;
	}

	public Object next() {
		if(!is_first || !it1.hasNext()) {
			remove_first=false;
			return it2.next();
		}
		Object ret = it1.next();
		if(!it1.hasNext()) is_first=false;
		return ret;
	}

	public void remove() {
		if(remove_first) it1.remove();
		else it2.remove();
	}
	
	public CompositeIterator(Iterator it1, Iterator it2) {
		this.it1 = it1;
		this.it2 = it2;
		is_first = true;
		remove_first=true;
	}
}
