package flowsim.util;

import java.lang.Math;
import java.util.Random;

public final class ExponentialDistribution implements Distribution
{
	Random random;
	double lambda;

	public double average() {
		return 1.0/lambda; // FIXME!!!!!!!!!
	}

	public double variance() {
		return lambda*lambda; // FIXME!!!!!!!!!
	}

	public double rand() {
		return -Math.log(1-random.nextDouble())/lambda;
	}

	public ExponentialDistribution(double lambda) {
		this.lambda = lambda;
		random = new Random();
	}

	public ExponentialDistribution(double lambda, long seed) {
		this.lambda = lambda;
		random = new Random(seed);
	}
	public ExponentialDistribution(double lambda, Random random) {
		this.lambda = lambda;
		this.random = random;
	}
}
