package flowsim.util;

import java.lang.Math;
import java.util.Random;

public final class UniformDistribution implements Distribution
{
	Random random;
	double low,high;

	public double average() {
		return (high+low)/2;
	}

	public double variance() {
		return Math.pow((high-low),2)/12;
	}

	public double rand() {
		return (high-low)*random.nextDouble()+low; 
	}      

	public UniformDistribution (double low, double high, long seed) {
		this.low  = low;
		this.high = high;
		random = new Random(seed);
	}
}
